import Flutter
import UIKit
import Appier

public class SwiftAirexSwiftPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "airex_swift_plugin", binaryMessenger: registrar.messenger())
    let instance = SwiftAirexSwiftPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

public func handle(_ call: FlutterMethodCall, result: FlutterResult) {

    if "configure" == call.method {
        if call.arguments != nil && (call.arguments is [String : Any]) {
            if call.arguments["appId"] != nil && call.arguments["isDev"] != nil {

                let appId = call.arguments["appId"] as? String
                let senderId = call.arguments["senderId"] as? String
                let appGroup = call.arguments["appGroup"] as? String
                let isDev = (call.arguments["isDev"] as? NSNumber)?.boolValue ?? false
                print("appId:\(appId ?? "")")
                print("senderId:\(senderId ?? "")")
                print("isDev:\(isDev)")
                print("appGroup:\(appGroup ?? "")")
                QGSdk.getSharedInstance().onStart(appId, withAppGroup: appGroup, setDevProfile: isDev)
                result(nil)
                return
            }
        }
        result(FlutterMethodNotImplemented)
    } else if "logEvent" == call.method {

        var parameters: [String : Any]? = nil
        if call.arguments["parameters"] != nil {
            if let object = call.arguments["parameters"] {
                print("parameters: \(object)")
            }
            parameters = call.arguments["parameters"] as? [AnyHashable : Any]
        }

        let vts = call.arguments["vts"] as? NSNumber
        print("vtc class Name \(NSStringFromClass(type(of: vts).self))")

        let vtsCurr = call.arguments["vtsCurr"] as? NSNumber
        print("vtsCurr class Name \(NSStringFromClass(type(of: vtsCurr).self))")

        if call.arguments["eventName"] != nil {
            QGSdk.getSharedInstance().logEvent(call.arguments["eventName"], withParameters: parameters, withValueToSum: vts, withValueToSumCurrency: vtsCurr)
        }

        result(nil)
    } else {
        result(FlutterMethodNotImplemented)
    }
  }
}
